#DEFINE CALL_Z(addr)            call $8C0C \ .dw addr
#DEFINE CALL_(addr)             call $8C0F \ .dw addr
#DEFINE CALL_NZ(addr)           call $8C12 \ .dw addr
#DEFINE CALL_C(addr)            call $8C18 \ .dw addr
#DEFINE CALL_NC(addr)           call $8C1E \ .dw addr
#DEFINE JUMP_Z(addr)            call $8C24 \ .dw addr
#DEFINE JUMP_(addr)             call $8C27 \ .dw addr
#DEFINE JUMP_NZ(addr)           call $8C2A \ .dw addr
#DEFINE JUMP_C(addr)            call $8C30 \ .dw addr
#DEFINE JUMP_NC(addr)           call $8C36 \ .dw addr
#DEFINE ROM_CALL(addr)          call addr
#DEFINE ROM_CALL_C(addr)        call c, addr
#DEFINE ROM_CALL_NC(addr)       call nc, addr
#DEFINE ROM_CALL_Z(addr)        call z, addr
#DEFINE ROM_CALL_NZ(addr)       call nz, addr
#DEFINE RCALL_(addr)            call $8CC8 \ .dw addr

         .org     0
         .include "usgard.h"
         .db      "Geometry Formulas",0
  
start:
  call &sub0
  ld   hl,&text1
  call &sub1
  ld   hl,&text2
  call &sub2
  ld   hl,&text3
  call &sub4
  ld   hl,&text4
  call &sub6
  ld   hl,&text5
  call &sub7
  ld   hl,&text6
  call D_ZT_STR
  call OTH_PAUSE
  
label_y:
  call &sub0
  ld   hl,&text7
  call &sub1
  ld   hl,&text8
  call &sub2
  ld   hl,&text9
  call &sub3
  ld   hl,&text10
  call &sub4
  ld   hl,&text11
  call &sub5
  ld   hl,&text12
  call &sub7
  ld   hl,&text14
  call D_ZT_STR
  
get1:
  call GET_KEY
  cp   K_F1
  jp   z,&label_a
  cp   K_F2
  jp   z,&label_b
  cp   K_F3
  jp   z,&label_c
  cp   K_EXIT
  jp   z,&label_z
  jr   get1
  
label_a:
  call &sub0
  ld   hl,&text15
  call &sub1
  ld   hl,&text16
  call &sub2
  ld   hl,&text17
  call &sub3
  ld   hl,&text18
  call &sub4
  ld   hl,&text19
  call &sub5
  ld   hl,&text20
  call &sub6
  ld   hl,&text21
  call D_ZT_STR
   
get2:
  call GET_KEY
  cp   K_F1
  jp   z,&label_aa
  cp   K_F2
  jp   z,&label_y
  cp   K_EXIT
  jp   z,&label_z
  jr   get2

label_aa:
  call &sub0
  ld   hl,&text22
  call &sub1
  ld   hl,&text23
  call &sub2
  ld   hl,&text24
  call &sub3
  ld   hl,&text25
  call &sub4
  ld   hl,&text26
  call &sub7
  ld   hl,&text29
  call D_ZT_STR
  
get3:
  call GET_KEY
  cp   K_F1
  jp   z,&label_a
  cp   K_EXIT
  jp   z,&label_z
  jr   get3

label_b:
  call &sub0
  ld   hl,&text30
  call &sub1
  ld   hl,&text31
  call &sub2
  ld   hl,&text32
  call &sub3
  ld   hl,&text33
  call &sub5
  ld   hl,&text35
  call D_ZT_STR
  
get4:
  call GET_KEY
  cp   K_F1
  jp   z,&label_y
  cp   K_EXIT
  jp   z,&label_z
  jr   get4

label_c:
  call &sub0
  ld   hl,&text36
  call &sub1
  ld   hl,&text37
  call &sub2
  ld   hl,&text38
  call &sub3
  ld   hl,&text39
  call &sub4
  ld   hl,&text40
  call &sub6
  ld   hl,&text42
  call D_ZT_STR
  jr   get4
  
sub0:
  call CLEARLCD
  ld   de,$0000
  ld   (CURSOR_ROW),de
  ret

sub1:
  call D_ZT_STR
  ld   de,$0001
  ld   (CURSOR_ROW),de
  ret

sub2:
  call D_ZT_STR
  ld   de,$0002
  ld   (CURSOR_ROW),de
  ret

sub3:
  call D_ZT_STR
  ld   de,$0003
  ld   (CURSOR_ROW),de
  ret

sub4:
  call D_ZT_STR
  ld   de,$0004
  ld   (CURSOR_ROW),de
  ret

sub5:
  call D_ZT_STR
  ld   de,$0005
  ld   (CURSOR_ROW),de
  ret

sub6:
  call D_ZT_STR
  ld   de,$0006
  ld   (CURSOR_ROW),de
  ret

sub7:
  call D_ZT_STR
  ld   de,$0007
  ld   (CURSOR_ROW),de
  ret

label_z:
  ret

text1:
.db "GEOMETRY",0
text2:
.db "FORMULAS",0
text3:
.db "V1.0",0
text4:
.db "(C) 2002",0
text5:
.db "WILSON NG",0
text6:
.db "WAESH@YAHOO",0
text7:
.db "1) GEOMETRIC",0
text8:
.db " FORMULAS",0
text9:
.db "2) DISTANCE/",0
text10:
.db " MIDPOINT",0
text11:
.db "3) LINES/",0
text12:
.db "CIRCLES",0
text14:
.db " 1   2    3",0
text15:
.db "TRIANGLE",0
text16:
.db "A=.5BH=1/2ABSINX",0
text17:
.db "CIRCLE",0
text18:
.db "A=R C=2R",0
text19:
.db "SECTOR OF CIRCLE",0
text20:
.db "A=1/2RX S=RX",0
text21:
.db "MORE BACK",0
text22:
.db "SPHERE A=4R",0
text23:
.db "V=4/3R^3",0
text24:
.db "CYLINDER",0
text25:
.db "CONE",0
text26:
.db "V=1/3RH",0
text29:
.db "BACK",0
text30:
.db "D=((X2-X1)+",0
text31:
.db "(Y2-Y1))",0
text32:
.db "((X1+X2)/2,",0
text33:
.db "(Y1+Y2)/2)",0
text35:
.db "BACK",0
text36:
.db "M = (Y2-Y1)/",0
text37:
.db "(X2-X1)",0
text38:
.db "Y-Y1=M(X-X1)",0
text39:
.db "Y=MX+B",0
text40:
.db "(X-H)+(Y-K)=R",0
text42:
.db "BACK",0

.end

